#!/bin/bash

VERSION=1
PRODUCT_SERIAL="`cat /sys/devices/virtual/dmi/id/product_serial`"

if lsusb -d 03eb:212c | grep -c Atmel > /dev/null 2>&1 ; then
	if [ "`cat "/usr/local/bin/ti/$PRODUCT_SERIAL" > /dev/null 2>&1`" != "$VERSION" ] ; then
		echo "Dumping current configuration file..."
		/usr/local/bin/ti/./mxt-app --save /usr/local/bin/ti/dump.cfg
		#Check if dump.cfg from system is the same as load.cfg firmware file, ignore lines lines 6 and 7.  
		#These lines are output diagnostic information fields and correspond to T44 and T5 in the Object-Base Server menu.
		if diff <(sed '6,7d' /usr/local/bin/ti/dump.cfg) <(sed '6,7d' /usr/local/bin/ti/load.cfg) > /dev/null 2>&1 ; then
			echo "Firmware configuration matches!"
			if [ "`cat "/usr/local/bin/ti/$PRODUCT_SERIAL" > /dev/null 2>&1`" != "$VERSION" ] ; then				
				#Create serial number file and echo firmware version into it.
				echo "Updating firmware version number..."
				echo "$VERSION" > /usr/local/bin/ti/$PRODUCT_SERIAL
			fi
		else
			echo "Loading new touch firmware configuration..."
			/usr/local/bin/ti/./mxt-app --load /usr/local/bin/ti/load.cfg
			echo "Firmware configuration updated!"
		fi
	else
		echo "Configuration file already loaded on this unit..."
	fi
else
	echo "This does not contain a Atmel touch controller"
fi
